//+------------------------------------------------------------------+
//|                                                              rsx |
//|      4 July 2012                                          mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1  LimeGreen
#property indicator_color2  LimeGreen
#property indicator_color3  PaleVioletRed
#property indicator_color4  PaleVioletRed
#property indicator_color5  DarkGray
#property indicator_width1  2
#property indicator_width3  2
#property indicator_width5  2
#property indicator_minimum -50
#property indicator_maximum +50

/*#property indicator_level1   30
#property indicator_level2  -30
#property indicator_level3   40
#property indicator_level4  -40
#property indicator_level5  0 
*/
//#property indicator_levelcolor Gold

//
//
//
//
//

extern int    Length  = 14;
extern int    Price   = PRICE_TYPICAL;
extern int    Depth   = 3;
extern double Speed   = 0.5;
extern bool   divergenceVisible         = false;
extern bool   divergenceOnValuesVisible = true;
extern bool   divergenceOnChartVisible  = true;
extern color  divergenceBullishColor    = LimeGreen;
extern color  divergenceBearishColor    = OrangeRed;
extern string divergenceUniqueID        = "rsx divergence1";
extern bool   ShowArrows                = false;
extern string ArrowsIdentifier          = "rsx arrows";
extern double ArrowsUpGap               = 0.20;
extern double ArrowsDownGap             = 1.25;
extern color  ArrowUpColor              = Lime;
extern int    ArrowUpWidth              = 2;
extern int    ArrowUpCode               = 241;
extern color  ArrowDownColor            = Red;
extern int    ArrowDownWidth            = 2; 
extern int    ArrowDownCode             = 242;

extern double Level1_value           = 40;
extern double Level2_value           = -40;
extern color  Levels_color           = Gold;
extern int    Levels_width           = 1;
extern int    Levels_style           = STYLE_DOT;

//
//
//
//
//

double rsx[];
double rsxHuu[];
double rsxHud[];
double rsxHdd[];
double rsxHdu[];
double slope[];
double trend[];

string shortName;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
      SetIndexBuffer(0,rsxHuu); SetIndexStyle(0, DRAW_HISTOGRAM);
      SetIndexBuffer(1,rsxHud); SetIndexStyle(1, DRAW_HISTOGRAM);
      SetIndexBuffer(2,rsxHdd); SetIndexStyle(2, DRAW_HISTOGRAM);
      SetIndexBuffer(3,rsxHdu); SetIndexStyle(3, DRAW_HISTOGRAM);
      SetIndexBuffer(4,rsx);
      SetIndexBuffer(5,slope);
      SetIndexBuffer(6,trend);
         Speed = MathMax(MathMin(1.5,Speed),0.1);
         Depth = MathMax(MathMin(10 ,Depth),1);
         shortName = divergenceUniqueID+": "+"Rsx ("+Length+","+Depth+","+DoubleToStr(Speed,2)+")";
         IndicatorShortName(shortName);
   return(0);
}

int deinit()
{
   int lookForLength = StringLen(divergenceUniqueID);
      for (int i=ObjectsTotal()-1; i>=0; i--) 
      {
         string name = ObjectName(i);  if (StringSubstr(name,0,lookForLength) == divergenceUniqueID) ObjectDelete(name);
      }
   lookForLength = StringLen(ArrowsIdentifier);
      for (i=ObjectsTotal(); i>= 0; i--)
      {
         name = ObjectName(i); if (StringSubstr(name,0,lookForLength) == ArrowsIdentifier) ObjectDelete(name);  
      }
      
   return(0); 
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double wrkBuffer[][41];

int start()
{
   int i,r,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(wrkBuffer,0) != Bars) ArrayResize(wrkBuffer,Bars);

   //
   //
   //
   //
   //
   
   double Kg = (3.0)/(2.0+Length); 
   double Hg = 1.0-Kg;
   for(i=limit, r=Bars-i-1; i>=0; i--, r++)
   {
      wrkBuffer[r][0] = iMA(NULL,0,1,0,MODE_SMA,Price,i);

         if (i==(Bars-1)) { for (int c=1; c<13; c++) wrkBuffer[r][c] = 0; continue; }  

      //
      //
      //
      //
      //
      
      double mom = wrkBuffer[r][0]-wrkBuffer[r-1][0];
      double moa = MathAbs(mom);
      for (int k=0; k<Depth; k++)
      {
         int kk = k*4;
            wrkBuffer[r][kk+1] = Kg*mom                + Hg*wrkBuffer[r-1][kk+1];
            wrkBuffer[r][kk+2] = Kg*wrkBuffer[r][kk+1] + Hg*wrkBuffer[r-1][kk+2]; mom =         1.5*wrkBuffer[r][kk+1] - Speed * wrkBuffer[r][kk+2];
            wrkBuffer[r][kk+3] = Kg*moa                + Hg*wrkBuffer[r-1][kk+3];
            wrkBuffer[r][kk+4] = Kg*wrkBuffer[r][kk+3] + Hg*wrkBuffer[r-1][kk+4]; moa = MathAbs(1.5*wrkBuffer[r][kk+3] - Speed * wrkBuffer[r][kk+4]);
      }
      if (moa != 0)
           rsx[i] = MathMax(MathMin((mom/moa+1.0)*50.0,100.00),0.00)-50.0; 
      else rsx[i] = 0;
      
      //
      //
      //
      //
      //
      
      rsxHuu[i] = EMPTY_VALUE;
      rsxHud[i] = EMPTY_VALUE;
      rsxHdd[i] = EMPTY_VALUE;
      rsxHdu[i] = EMPTY_VALUE;
      slope[i]  = slope[i+1];
      trend[i]  = trend[i+1];
         if (rsx[i]>rsx[i+1]) slope[i] =  1;
         if (rsx[i]<rsx[i+1]) slope[i] = -1;
         if (rsx[i]>0)        trend[i] =  1;
         if (rsx[i]<0)        trend[i] = -1;
         if (rsx[i]>0)
         if (slope[i]==1)
               rsxHuu[i] = rsx[i];
         else  rsxHud[i] = rsx[i];
         if (rsx[i]<0)
         if (slope[i]==1)
               rsxHdu[i] = rsx[i];
         else  rsxHdd[i] = rsx[i];
         if (divergenceVisible)
         {
           CatchBullishDivergence(rsx,i);
           CatchBearishDivergence(rsx,i);
         } 
         manageArrow(i);
   }
   
   //
   //
   //
   //
   //
   ShowLevels();
   return( 0 );
}


void ShowLevels()
{
   static int bars = 0;
   if( Bars <= bars ) return;
   
   bars = Bars;
   
   int window = WindowFind(shortName);
   
   string level1 = shortName + "#" + "level1";
   string level2 = shortName + "#" + "level2";
   
   //if( ObjectFind("level1") != window )
      ObjectCreate(level1, OBJ_TREND, window, Time[Bars-1], Level1_value, Time[0], Level1_value);
   ObjectSet(level1, OBJPROP_TIME1, Time[Bars-1]);
   ObjectSet(level1, OBJPROP_TIME2, Time[0]);
   ObjectSet(level1, OBJPROP_PRICE1, Level1_value);
   ObjectSet(level1, OBJPROP_PRICE2, Level1_value);
   ObjectSet(level1, OBJPROP_COLOR, Levels_color);
   ObjectSet(level1, OBJPROP_WIDTH, Levels_width);
   ObjectSet(level1, OBJPROP_STYLE, Levels_style);
   ObjectSet(level1, OBJPROP_RAY, false);
   
   //if( ObjectFind("level2") != window )
      ObjectCreate(level2, OBJ_TREND, window, Time[Bars-1], Level2_value, Time[0], Level2_value);
   ObjectSet(level2, OBJPROP_TIME1, Time[Bars-1]);
   ObjectSet(level2, OBJPROP_TIME2, Time[0]);
   ObjectSet(level2, OBJPROP_PRICE1, Level2_value);
   ObjectSet(level2, OBJPROP_PRICE2, Level2_value);
   ObjectSet(level2, OBJPROP_COLOR, Levels_color);
   ObjectSet(level2, OBJPROP_WIDTH, Levels_width);
   ObjectSet(level2, OBJPROP_STYLE, Levels_style);
   ObjectSet(level2, OBJPROP_RAY, false);
}


//--------------------------------------------------------------------------------------------------------------------+
//
//--------------------------------------------------------------------------------------------------------------------+
//
//
//
//
//

void manageArrow(int i)
{
   if (ShowArrows)
   {
      ObjectDelete(ArrowsIdentifier+Time[i]);         
            
      //
      //
      //
      //
      //
           
      if (trend[i] != trend[i+1])
      {
         string name = ArrowsIdentifier+Time[i];
         if (trend[i] == 1)
         {
            ObjectCreate(name,OBJ_ARROW,0, Time[i],Low[i]-ArrowsUpGap*iATR(NULL,0,20,i));
               ObjectSet(name,OBJPROP_ARROWCODE,ArrowUpCode);
               ObjectSet(name,OBJPROP_COLOR,ArrowUpColor);
               ObjectSet(name,OBJPROP_WIDTH,ArrowUpWidth);
         }
         else
         {
            ObjectCreate(name,OBJ_ARROW,0, Time[i],High[i]+ArrowsDownGap*iATR(NULL,0,20,i));
               ObjectSet(name,OBJPROP_ARROWCODE,ArrowDownCode);
               ObjectSet(name,OBJPROP_COLOR,ArrowDownColor);
               ObjectSet(name,OBJPROP_WIDTH,ArrowDownWidth);
         }
      }
   }
}

//-------------------------------------------------------------------------------------------------
//
//-------------------------------------------------------------------------------------------------
//
//
//
//
//

void CatchBullishDivergence(double& values[], int i)
{
   i++;
            ObjectDelete(divergenceUniqueID+"l"+DoubleToStr(Time[i],0));
            ObjectDelete(divergenceUniqueID+"l"+"os" + DoubleToStr(Time[i],0));            
   if (!IsIndicatorLow(values,i)) return;  

   //
   //
   //
   //
   //

   int currentLow = i;
   int lastLow    = GetIndicatorLastLow(values,i+1);
      if (values[currentLow] > values[lastLow] && Low[currentLow] < Low[lastLow])
      {
         if(divergenceOnChartVisible)  DrawPriceTrendLine("l",Time[currentLow],Time[lastLow],Low[currentLow],Low[lastLow],divergenceBullishColor,STYLE_SOLID);
         if(divergenceOnValuesVisible) DrawIndicatorTrendLine("l",Time[currentLow],Time[lastLow],values[currentLow],values[lastLow],divergenceBullishColor,STYLE_SOLID);
      }
      if (values[currentLow] < values[lastLow] && Low[currentLow] > Low[lastLow])
      {
         if(divergenceOnChartVisible)  DrawPriceTrendLine("l",Time[currentLow],Time[lastLow],Low[currentLow],Low[lastLow], divergenceBullishColor, STYLE_DOT);
         if(divergenceOnValuesVisible) DrawIndicatorTrendLine("l",Time[currentLow],Time[lastLow],values[currentLow],values[lastLow], divergenceBullishColor, STYLE_DOT);
      }
}

//
//
//
//
//

void CatchBearishDivergence(double& values[], int i)
{
   i++; 
            ObjectDelete(divergenceUniqueID+"h"+DoubleToStr(Time[i],0));
            ObjectDelete(divergenceUniqueID+"h"+"os" + DoubleToStr(Time[i],0));            
   if (IsIndicatorPeak(values,i) == false) return;

   //
   //
   //
   //
   //
      
   int currentPeak = i;
   int lastPeak = GetIndicatorLastPeak(values,i+1);
      if (values[currentPeak] < values[lastPeak] && High[currentPeak]>High[lastPeak])
      {
         if (divergenceOnChartVisible)  DrawPriceTrendLine("h",Time[currentPeak],Time[lastPeak],High[currentPeak],High[lastPeak],divergenceBearishColor,STYLE_SOLID);
         if (divergenceOnValuesVisible) DrawIndicatorTrendLine("h",Time[currentPeak],Time[lastPeak],values[currentPeak],values[lastPeak],divergenceBearishColor,STYLE_SOLID);
      }
      if(values[currentPeak] > values[lastPeak] && High[currentPeak] < High[lastPeak])
      {
         if (divergenceOnChartVisible)  DrawPriceTrendLine("h",Time[currentPeak],Time[lastPeak],High[currentPeak],High[lastPeak], divergenceBearishColor, STYLE_DOT);
         if (divergenceOnValuesVisible) DrawIndicatorTrendLine("h",Time[currentPeak],Time[lastPeak],values[currentPeak],values[lastPeak], divergenceBearishColor, STYLE_DOT);
      }
}

//
//
//
//
//

bool IsIndicatorPeak(double& values[], int i) { return(values[i] >= values[i+1] && values[i] > values[i+2] && values[i] > values[i-1]); }
bool IsIndicatorLow( double& values[], int i) { return(values[i] <= values[i+1] && values[i] < values[i+2] && values[i] < values[i-1]); }

int GetIndicatorLastPeak(double& values[], int shift)
{
   for(int i = shift+5; i<Bars; i++)
         if (values[i] >= values[i+1] && values[i] > values[i+2] && values[i] >= values[i-1] && values[i] > values[i-2]) return(i);
   return(-1);
}
int GetIndicatorLastLow(double& values[], int shift)
{
   for(int i = shift+5; i<Bars; i++)
         if (values[i] <= values[i+1] && values[i] < values[i+2] && values[i] <= values[i-1] && values[i] < values[i-2]) return(i);
   return(-1);
}

//+---------------------------------------------------------------------------------------------------------------------------------------+
//|                                                                  
//+---------------------------------------------------------------------------------------------------------------------------------------+
//
//
//
//
//

void DrawPriceTrendLine(string first,datetime t1, datetime t2, double p1, double p2, color lineColor, double style)
{
   string   label = divergenceUniqueID+first+"os"+DoubleToStr(t1,0);
    
   ObjectDelete(label);
      ObjectCreate(label, OBJ_TREND, 0, t1+Period()*60-1, p1, t2, p2, 0, 0);
         ObjectSet(label, OBJPROP_RAY, false);
         ObjectSet(label, OBJPROP_COLOR, lineColor);
         ObjectSet(label, OBJPROP_STYLE, style);
}
void DrawIndicatorTrendLine(string first,datetime t1, datetime t2, double p1, double p2, color lineColor, double style)
{
   int indicatorWindow = WindowFind(shortName);
   if (indicatorWindow < 0) return;
   
   string label = divergenceUniqueID+first+DoubleToStr(t1,0);
   ObjectDelete(label);
      ObjectCreate(label, OBJ_TREND, indicatorWindow, t1+Period()*60-1, p1, t2, p2, 0, 0);
         ObjectSet(label, OBJPROP_RAY, false);
         ObjectSet(label, OBJPROP_COLOR, lineColor);
         ObjectSet(label, OBJPROP_STYLE, style);
}